;ind10
; - - - - - 
          list      p=16f84A  ;
          __CONFIG  03FF1H    ;
; - - - - -                    
indf      equ       00h       ;
pcl       equ       02h       ;
status    equ       03h       ;
fsr       equ       04h       ;
trisa     equ       85h       ;
porta     equ       05h       ;
trisb     equ       86h       ;
portb     equ       06h       ;
option_reg equ      81h       ;
eedata    equ       08h       ;
eeadr     equ       09h       ;
eecon1    equ       88h       ;
eecon2    equ       89h       ;
intcon    equ       0Bh       ;
REGPS     equ       0Ch       ;опньедьхи спнбемэ-20- 
TMP       equ       0Dh       ;дкхрекэмнярэ нряверю
REGPR     equ       0Eh       ;рейсыхи спнбемэ 
SECL_1    equ       0Fh       ;оепелеммюъ пюгбепрйх
REZ0      equ       10h       ;
REZ1      equ       11h       ;
REZ2      equ       12h       ;
REZ3      equ       13h       ;
REZ4      equ       14h       ;
REZ5      equ       15h       ;
REZ6      equ       16h       ;
REZ7      equ       17h       ;
REZ8      equ       18h       ;
REZ9      equ       19h       ;
REZ10     equ       1Ah       ;
REZ11     equ       1Bh       ;
REZ12     equ       1Ch       ;
REZ13     equ       1Dh       ;
REZ14     equ       1Eh       ;
REZ15     equ       1Fh       ;-40-
SECL_2    equ       20h       ;дкхрекэмнярэ пюгбепрйх
INF       equ       21h       ;жхйк сопюбкемхъ
POZ       equ       22h       ;явервхй онгхжхи фйх
NM1       equ       23h       ;мнлеп нряверю
T_EXT     equ       24h       ;бмеьмхи жхйк оюсгш
T_INT     equ       25h       ;бмсрпеммхи жхйк оюсгш
M_BYTE    equ       26h       ;аюир оняшкйх
T_INI     equ       27h       ;опепшб/лемч
T_PR      equ       28h       ;опнбепйю яхлбнкнб 
; - - - - - 
W         equ       .0        ;
RP0       equ       .5        ;-50-
Z         equ       .2        ;
F         equ       .1        ;
DC        equ       .1        ;
;11110000=.240 рерп спнбмъ, 00001111=.15 рерп бпелемх 
          org       0         ;
          GOTO      START     ;
;- - - - - ондопнцпюллю опепшбюмхъ
          org       4         ;
          BCF       intcon,7  ;гюопер опепшбюмхи
          BCF       status,Z  ;
          CALL      PAUSE_INI ;юмрхдпеаегц
          MOVF      T_INI,W   ;-60-
          ADDWF     T_INI,W   ;
          ADDWF     T_INI,W   ;
          NOP                 ;
          MOVWF     T_INI     ;пюгбепрйю У3
          SUBLW     .217      ;
          BTFSS     status,Z  ;
          GOTO      RZ        ;
          MOVLW     .1        ;
          MOVWF     T_INI     ;
          BCF       status,Z  ;
RZ        MOVLW     .144      ;
          MOVWF     intcon    ;пюгпеьемхе INT 10010000
          MOVLW     .3        ;
          MOVWF     T_EXT     ;опнднкфемхе опнжедсп
          MOVWF     T_INT     ;       оюсгю
          RETURN              ;
START     CLRWDT              ;
          CLRF      porta     ;
          CLRF      portb     ;
          MOVLW     .1        ;
          MOVWF     SECL_2    ;сяр.дкхр.пюгбепрйх
          MOVWF     SECL_1    ;-
          MOVWF     T_INI     ;
          MOVLW     .255      ;опедсярюмнбйю рлп-80-
          MOVWF     TMP       ;        
          MOVLW     .0        ;
          MOVWF     INF       ;- 
          MOVWF     REGPS     ;-
          MOVWF     POZ       ;-
          MOVWF     NM1       ;-
          BSF       status,RP0;
          MOVLW     .143      ;=10001111БШЙК ОНДР ПЕГ
          MOVWF     option_reg; бйк декхрекэ WDT 1:128 -90    
          MOVLW     .243      ;=11110011
          MOVWF     trisb     ;B-опл 4-7,0Х1 опд 2Х3
          MOVLW     .0        ; 
          MOVWF     trisa     ;ю-опд 0-4 
          BCF       status,RP0;
          BSF       portb,3   ;бйк оепеяверю южо
          BSF       porta,2   ;ХМРЕПТЕИЯ фйх
          BSF       porta,4   ;-
; - - - - - хмхжхюкхгюжхъ фйх  
          BCF       intcon,7  ;гюопер опепшбюмхи   
          CALL      PAUSE_INI ;
          BCF       portb,2   ;RS=0, оепедювю йнлюмд
          CALL      IN_PK3    ; 
          CALL      ZAPIS     ;оепедювю ярюпьецн о-ар 
          CALL      PAUSE4    ; 
          CALL      PAUSE4    ;
          CALL      PAUSE4    ;
          CALL      IN_PK3    ; 
          CALL      ZAPIS     ;оепедювю ярюпьецн о-ар 
          CALL      PAUSE3    ;
          CALL      IN_PK3    ; 
          CALL      ZAPIS     ;оепедювю ярюпьецн о-ар 
          CALL      PAUSE3    ;  
          MOVLW     .2        ;-FUNCTION SET 
          MOVWF     M_BYTE    ;-100-
          CALL      IN_PORT   ;
          CALL      ZAPIS     ;оепедювю ярюпьецн о-ар 
          CALL      PAUSE3    ; 
          CALL      ZAPIS     ;оепедювю ярюпьецн о-ар
          CALL      PAUSE3    ;
          MOVLW     .8        ;
          MOVWF     M_BYTE    ;
          CALL      IN_PORT   ;
          CALL      ZAPIS     ;оепедювю лкюдьецн о-ар-110 
          CALL      PAUSE3    ;
          CALL      IN_PK0    ;-DISPLAY ON CONTROL
          CALL      ZAPIS     ;
          CALL      PAUSE3    ;
          MOVLW     .8        ;
          MOVWF     M_BYTE    ;
          CALL      IN_PORT   ;
          CALL      ZAPIS     ;-120-
          CALL      PAUSE3    ;
          CALL      IN_PK0    ;-DISPLAY CLEAR
          CALL      ZAPIS     ; 
          CALL      PAUSE3    ;
          MOVLW     .12       ;
          MOVWF     M_BYTE    ;
          CALL      IN_PORT   ;
          CALL      ZAPIS     ;-130-
          CALL      PAUSE3    ;
          CALL      IN_PK0    ;-ENTRY MODE SET  
          CALL      ZAPIS     ;
          CALL      PAUSE3    ;
          MOVLW     .6        ; 
          MOVWF     M_BYTE    ;
          CALL      IN_PORT   ;
          CALL      ZAPIS     ;-140-
          CALL      PAUSE4    ;
          BSF       portb,2   ;пефхл фйх-дюммше
          BSF       porta,4   ;хмрептеия фйх
          BSF       porta,2   ;-
          MOVLW     .144      ;пюгпеьемхе INT 10010000
          MOVWF     intcon    ;
; - - - - -ЙНМЕЖ ХМХЖХЮКХГЮЖХХ
          CALL      MYSIMV10  ;
          CALL      MYSIMV11  ;
          CALL      MYSIMV12  ;
          CALL      MYSIMV13  ;
          CALL      MYSIMV14  ;
          CALL      MYSIMV15  ;
          CALL      PROV_SIM  ;
          CALL      WR_EEP    ;
          CALL      IND       ;
          MOVLW     .9        ;
          MOVWF     T_INI     ;
          MOVWF     INF       ;
; - - - - -жхйк сопюбкемхъ
C_IND     BCF       status,Z  ;
          CLRWDT              ;
          CALL      PAUSE4    ;
          MOVF      T_INI,W   ;
          SUBWF     INF,W     ;опнбепйю намнбкемхъ
          BTFSC     status,Z  ;
          GOTO      C_IND     ;
          MOVLW     .1        ;
          SUBWF     T_INI,W   ;
          BTFSC     status,Z  ;
          CALL      WR_EEP    ;гюохяэ REZ0-15
          BCF       status,Z  ;
          CALL      PAUSE3    ;
          MOVLW     .3        ;
          SUBWF     T_INI,W   ;
          BTFSC     status,Z  ;
          CALL      CLR_LCD   ;нвхярйю дхяокеъ
          BCF       status,Z  ;
          CALL      PAUSE3    ;
          MOVLW     .9        ;
          SUBWF     T_INI,W   ;
          BTFSC     status,Z  ;
          CALL      RD_EEP    ;бшгнб гюохя.б ееп
          BCF       status,Z  ; REZ0-15 я хмд.
          CALL      PAUSE3    ;
          MOVLW     .27       ;
          SUBWF     T_INI,W   ;
          BTFSC     status,Z  ;
          CALL      COMP      ;
          BCF       status,Z  ;
          CALL      PAUSE3    ;
          MOVLW     .81       ;
          SUBWF     T_INI,W   ;
          BTFSC     status,Z  ;
          CALL      RAZV      ;
          BCF       status,Z  ; 
          CALL      PAUSE3    ;
          MOVLW     .243      ;
          SUBWF     T_INI,W   ;
          BTFSC     status,Z  ;
          CALL      RAZV      ;
          GOTO      C_IND     ;                      
; - - - - - жхтпнбни йнлоюпюрнп нрявернб REZ0-15
COMP      BCF       intcon,7  ;гюоп опепшбюмхи
          CALL      U_OUT     ;
          CALL      U_INP     ;
          MOVF      REGPR,W   ;
          MOVWF     REGPS     ;
          MOVWF     REZ0      ;
METKA6    BCF       status,Z  ;яапня ткюцю мскъ 
          MOVLW     .0        ;-опедсярюмнбйю TMP
          MOVWF     TMP       ;мнбнцн бпел.хмрепб.NM1 
METKA4    MOVF      SECL_2,W  ;жхйк явхршбюмхъ хг южо
          MOVWF     SECL_1    ;сярюмнбйю пюгбепрйх
METKA2    DECFSZ    SECL_1,F  ;жхйк пюгбепрйх
          GOTO      METKA2    ; 
          INCF      TMP,F     ;
          CALL      U_INP     ; 
          MOVF      REGPR,W   ; 
          SUBWF     REGPS,W   ;
          BTFSS     status,Z  ;
          GOTO      METKA3    ;пюгкхвмше нряверш
          BCF       status,Z  ;ндхмюйнбше нряверш
          MOVF      TMP,W     ;
          SUBLW     .15       ;
          BTFSS     status,Z  ;
          GOTO      METKA4    ;мюйнокемхе нряверю
          BCF       status,Z  ;
METKA3    MOVLW     .16       ;нопедекемхе х гюохяэ
          ADDWF     NM1,W     ;нряверю
          MOVWF     fsr       ;гюохяэ мнлепю REZ
          MOVF      REGPS,W   ;-гюохяэ б юйй бшап.мнлепю
          ADDWF     TMP,W     ;-
          MOVWF     indf      ;-гюохяэ нряверю REZ  
          MOVF      NM1,W     ;-160-
          SUBLW     .15       ; 
          BTFSC     status,Z  ; 
          GOTO      METKA5    ;
          INCF      NM1,F     ;-ондцнрнбйю мнбнцн нряверю
          MOVF      REGPR,W   ;-оепегюохяэ спнбмъ
          MOVWF     REGPS     ;-рейсыецн б опньедьхи
          GOTO      METKA6    ;
METKA5    CLRF      NM1       ;
          MOVF      T_INI,W   ;
          MOVWF     INF       ;
          BSF       intcon,7  ;пюгп опепшбюмхи
          CALL      IND       ;
          RETURN              ;
; - - - - -сярюмнбйю пюгбепрйх
RAZV      BTFSC     portb,1   ;опнбепйю"тсмйж"
          GOTO      RZ1       ;
          MOVF      T_INI,W   ;
          MOVWF     SECL_2    ;
          CALL      PROV_SIM  ;
          CALL      IND       ;
RZ1       MOVF      T_INI,W   ;
          MOVWF     INF       ;
          RETURN              ;  
; - - - - -хмдхйюжхъ дюммшу б фйх
IND       BCF       intcon,7  ;гюопер опепшбюмхи 
          BCF       status,Z  ;
          BCF       portb,2   ;RS=0 йнлюмдш
          MOVLW     .0        ;DISPLAY CLEAR  
          MOVWF     M_BYTE    ; 
          CALL      IN_PORT   ; 
          CALL      ZAPIS     ;
          CALL      PAUSE3    ;
          MOVLW     .1        ; 
          MOVWF     M_BYTE    ;
          CALL      IN_PORT   ;
          CALL      ZAPIS     ;-140-
          CALL      PAUSE4    ;
          MOVLW     .8        ;SET DDRAM ADDRESS 
          MOVWF     M_BYTE    ;гюохяэ оепбни ярпнйх
          CALL      IN_PORT   ; 
          CALL      ZAPIS     ;-200-
          CALL      PAUSE3    ;
          MOVLW     .0        ;гюохяэ я мскебни онг 
          MOVWF     M_BYTE    ; 
          CALL      IN_PORT   ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          BSF       portb,2   ;RS=1-бшбнд яхлбнкю мю фйх
          MOVLW     .0        ;сяр явервхйю онгхжхи 
          MOVWF     POZ       ;
SIMV1     BCF       status,DC ;яапня тк оепемняю
          MOVLW     .16       ;-210-
          ADDWF     POZ,W     ; 
          MOVWF     fsr       ;
          MOVF      indf,W    ;
          SWAPF     W,0       ;нрявер б оепб рерпюдс
          ANDLW     .15       ;нрявер у 00001111 
          MOVWF     M_BYTE    ;гюохяэ нряверю б M_BYTE 
          SUBLW     .9        ;
          NOP                 ;
          BTFSC     status,DC ;опнбепйю бекхвхмш
          GOTO      UST1      ;-220-
          MOVLW     .10       ;
          SUBWF     M_BYTE,F  ;
          CALL      IN_PK0    ;бшанп ярка онкэгнбюрекъ
          CALL      ZAPIS     ;
          CALL      PAUSE3    ;
          CALL      IN_PORT   ;бшбнд яхлб онкэгнбюр
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;-йнмеж бшбндю яхлб онкэг
          GOTO      SIMV11    ; 
UST1      CALL      IN_PK3    ;бшанп опнцпюлмнцн ярка-230
          CALL      ZAPIS     ;
          CALL      PAUSE3    ;
          CALL      IN_PORT   ;
          CALL      ZAPIS     ;-йнмеж бшбндю опнцп.яхлб
          CALL      PAUSE4    ;
SIMV11    INCF      POZ,F     ; 
          MOVF      POZ,W     ; 
          SUBLW     .16       ; 
          BTFSS     status,Z  ; 
          GOTO      SIMV1     ;
          BCF       status,Z  ;
          CALL      PAUSE3    ;-бшбнд 2и ярпнйх
          BCF       portb,2   ;RS=0 SET DDRAM ADDRESS 
          MOVLW     .12       ;гюохяэ брнпни ярпнйх  
          MOVWF     M_BYTE    ; 
          CALL      IN_PORT   ; 
          CALL      ZAPIS     ;
          CALL      PAUSE3    ;
          MOVLW     .0        ;гюохяэ я мскебни онг
          MOVWF     M_BYTE    ;
          CALL      IN_PORT   ;
          CALL      ZAPIS     ;-250-
          CALL      PAUSE4    ;
          CLRWDT              ;
          BSF       portb,2   ;RS=1-бшбнд яхлбнкю мю фйх
          MOVLW     .0        ;сяр явервхйю онгхжхи  
          MOVWF     POZ       ; 
SIMV2     BCF       status,DC ;яапня ткюцю оепемняю
          MOVLW     .16       ;
          ADDWF     POZ,W     ;
          MOVWF     fsr       ;
          MOVF      indf,W    ; 
          ANDLW     .15       ;нрявер у 00001111-260-
          MOVWF     M_BYTE    ;гюохяэ нряверю б M_BYTE
          SUBLW     .9        ;
          NOP                 ;
          BTFSC     status,DC ;опнбепйю бекхвхмш
          GOTO      UST2      ;
          MOVLW     .10       ;
          SUBWF     M_BYTE,F  ;
          CALL      IN_PK0    ;бшанп ярнкажю онкэгнбюрекъ
          CALL      ZAPIS     ;
          CALL      PAUSE3    ;-270-
          CALL      IN_PORT   ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;-йнмеж бшбндю яхлбнкю
          GOTO      SIMV21    ; онкэгнбюрекъ
UST2      CALL      IN_PK3    ;бшанп опнцп ярнкажю
          CALL      ZAPIS     ;
          CALL      PAUSE3    ;
          CALL      IN_PORT   ;-  
          CALL      ZAPIS     ; 
          CALL      PAUSE4    ;-йнмеж бшбндю опнц.яхлб-280
SIMV21    INCF      POZ,F     ;
          MOVF      POZ,W     ;
          SUBLW     .16       ;
          BTFSS     status,Z  ;
          GOTO      SIMV2     ; 
          BCF       status,Z  ;
SIMV3     BSF       porta,2   ;ХМРЕПТЕИЯ фйх
          BSF       porta,4   ;-
          BSF       portb,2   ;ДЮММШЕ
          BSF       intcon,7  ;пюгпеьемхе опепшбюмхи
          CLRWDT              ;
          RETURN              ;
; - - - - -нвхярйю дхяокеъ
CLR_LCD   BCF       intcon,7  ;гюопер опепшбюмхи 
          BCF       portb,2   ;RS=0 йнлюмдш
          CALL      IN_PK0    ;DISPLAY CLEAR 
          CALL      ZAPIS     ;
          CALL      PAUSE3    ;
          CALL      IN_PK1    ;
          CALL      ZAPIS     ;-140-
          CALL      PAUSE4    ;
          BSF       porta,2   ;ХМРЕПТЕИЯ фйх
          BSF       porta,4   ;-
          BSF       portb,2   ;ДЮММШЕ
          BSF       intcon,7  ;пюгпеьемхе опепшбюмхи
          MOVLW     .3        ;осмйр
          MOVWF     INF       ;лемч
          RETURN              ;
; - - - - -явхршбюмхе хг южо   -290-
U_INP     BCF       portb,3   ;явхршбюмхе хг южо
          NOP                 ;
          MOVF      portb,W   ;
          ANDLW     .240      ;
          MOVWF     REGPR     ;
          BSF       portb,3   ;
          RETURN              ;
; - - - - -гюосяй хлоскэяю
U_OUT     BCF       portb,3   ;сякнбхе хлоскэяю
          BCF       portb,2   ;-
          NOP                 ;
          NOP                 ;
          BSF       portb,3   ;
          BSF       portb,2   ;
          RETURN              ;      
; - - - - -гюохяэ о-а йндю б гюыекйх онпрнб 
IN_PORT   BTFSC     M_BYTE,0  ;-гюохяэ 0-цн ахрю
          BSF       porta,0   ;- 
          BTFSS     M_BYTE,0  ;- 
          BCF       porta,0   ;-
          BTFSC     M_BYTE,1  ;-гюохяэ 1-цн ахрю  
          BSF       porta,1   ;-320-
          BTFSS     M_BYTE,1  ;
          BCF       porta,1   ;- 
          BTFSC     M_BYTE,2  ;-гюохяэ 2-цн ахрю
          BSF       porta,2   ;- 
          BTFSS     M_BYTE,2  ;- 
          BCF       porta,2   ;- 
          BTFSC     M_BYTE,3  ;-гюохяэ 3-цн ахрю 
          BSF       porta,3   ;-
          BTFSS     M_BYTE,3  ; 
          BCF       porta,3   ;-330-
          RETURN              ; 
; - - - - -оепедювю йндю б фйх  
ZAPIS     BSF       porta,4   ;МЮ 2 ЛЙЯ
          NOP                 ; 
          NOP                 ;
          NOP                 ; 
          BCF       porta,4   ;
          RETURN              ; 
; - - - - -оюсгю 203 лйя
PAUSE3    MOVLW     .40       ; (40/1)!
          MOVWF     T_INT     ;-340-
CIKL1     NOP                 ; 
          NOP                 ; 
          DECFSZ    T_INT,F   ;
          GOTO      CIKL1     ; 
          RETURN              ; 
; - - - - -оюсгю >1,53 ля        
PAUSE4    MOVLW     .8        ;(8/1)! 
          MOVWF     T_EXT     ;
CIKL2     MOVLW     .40       ;(40/1)! 
          MOVWF     T_INT     ;-350-
CIKL3     NOP                 ;
          NOP                 ;
          DECFSZ    T_INT,F   ;
          GOTO      CIKL3     ; 
          DECFSZ    T_EXT,F   ; 
          GOTO      CIKL2     ; 
          RETURN              ;
; - - - - -
PAUSE_INI BSF       porta,2   ;ХМРЕПТЕИЯ фйх
          BSF       porta,4   ;-
          MOVLW     .255      ;(255/1)!
          MOVWF     T_PR      ;
CIKL4     CALL      PAUSE4    ;
          CALL      PAUSE4    ;
          DECFSZ    T_PR,F    ;
          GOTO      CIKL4     ;
          RETURN              ;
; - - - - -
IN_PK0    BCF       porta,0   ;мнкэ онкэгнбюрекъ фйх 
          BCF       porta,1   ;
          BCF       porta,2   ;-360-
          BCF       porta,3   ; 
          RETURN              ;
IN_PK1    BSF       porta,0   ;едемхжю онкэг. фйх-340 
          BCF       porta,1   ;
          BCF       porta,2   ;
          BCF       porta,3   ; 
          RETURN              ;
IN_PK3    BSF       porta,0   ;3-ъ йнкнмйю фйх 
          BSF       porta,1   ;рпнийю онкэгнбюрекъ фйх
          BCF       porta,2   ;-370-
          BCF       porta,3   ; 
          RETURN              ; 
IN_PK7    BSF       porta,0   ;яелепйю онкэг. фйх 
          BSF       porta,1   ;
          BSF       porta,2   ;
          BCF       porta,3   ; 
          RETURN              ;
IN_PK4    BCF       porta,0   ;вербепйю онкэгнбюрекъ фйх 
          BCF       porta,1   ;
          BSF       porta,2   ;-380-
          BCF       porta,3   ; 
          RETURN              ;
IN_PK9    BSF       porta,0   ;дебърйю онкэгнбюрекъ фйх 
          BCF       porta,1   ;
          BCF       porta,2   ;-380-
          BSF       porta,3   ; 
          RETURN              ;
; - - - - -гюохяэ дюммшу б ееп хг REZ0-15
WR_EEP    BTFSC     portb,1   ;
          GOTO      WR1       ;
          BCF       intcon,7  ;гюопер опепшбюмхи
          CLRF      NM1       ;
          CLRF      fsr       ;
          BCF       status,Z  ;
BEG_WR    BSF       status,RP0;!
          CLRF      eecon1    ;
          CLRF      eecon2    ;
          BCF       status,RP0;!
          MOVF      NM1,W     ;
          MOVWF     eeadr     ;гюохяэ юдп ееп
          MOVLW     .16       ;
          ADDWF     NM1,W     ;
          MOVWF     fsr       ;
          MOVF      indf,W    ;
          MOVWF     eedata    ;гюохяэ б ееп
          BSF       status,RP0;
          BCF       intcon,7  ;
          BSF       eecon1,2  ;
          MOVLW     055h      ;опнжедспю гюохях
          MOVWF     eecon2    ;- -
          MOVLW     0AAh      ;- -
          MOVWF     eecon2    ;- -
          BSF       eecon1,1  ;- -
          CALL      PAUSE4    ;- -
          CALL      PAUSE4    ;- -
          CALL      PAUSE4    ;- -
          BCF       eecon1,2  ;
          BCF       status,RP0;
          INCF      NM1,F     ;
          MOVF      NM1,W     ;
          SUBLW     .16       ;
          BTFSS     status,Z  ;нопедекемхе йнмжю
          GOTO      BEG_WR    ;
          BCF       status,Z  ;
          CLRF      NM1       ;
          BSF       intcon,7  ;пюгп опепшбюмхи
WR1       MOVLW     .1        ;осмйр
          MOVWF     INF       ;лемч
          RETURN              ;
; - - - - -времхе дюммшу хг ееп б REZ0-15
RD_EEP    BTFSC     portb,1   ;
          GOTO      RD1       ;
          BCF       intcon,7  ;гюопер опепшбюмхи
          CLRF      NM1       ;
          CLRF      fsr       ;
          BCF       status,Z  ;
          BSF       status,RP0;
          CLRF      eecon1    ;
          CLRF      eecon2    ;
          BCF       status,RP0;
BEG_RD    MOVF      NM1,W     ;
          MOVWF     eeadr     ;гюохяэ юдпеяю ееп
          BSF       status,RP0;
          BSF       eecon1,0  ;хмхжхюкхг времхъ
          BCF       status,RP0;
          MOVLW     .16       ;
          ADDWF     NM1,W     ;
          MOVWF     fsr       ;
          MOVF      eedata,W  ;времхе хг ееп
          MOVWF     indf      ;б пецхярпш REZ
          INCF      NM1,F     ;
          MOVF      NM1,W     ;
          SUBLW     .16       ;
          BTFSS     status,Z  ;нопедекемхе йнмжю
          GOTO      BEG_RD    ;
          BCF       status,Z  ;
          CLRF      NM1       ;
          BSF       intcon,7  ;пюгп опепшбюмхи
          CALL      IND       ;
RD1       MOVLW     .9        ;осмйр
          MOVWF     INF       ;лемч
          RETURN              ;
MYSIMV10  MOVLW     .4        ;яр.онксаюир
          MOVWF     M_BYTE    ;
          CALL      IN_PORT   ;
          BCF       portb,2   ;йнлюмдю мю фйх
          CALL      ZAPIS     ;
          CALL      PAUSE3    ;
          MOVLW     .0        ;лкюдь.онксаюир
          MOVWF     M_BYTE    ;-390-
          CALL      IN_PORT   ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
;гюохяэ яхлбнкю 10 б мскебсч ъвеийс CGRAM
          BSF       portb,2   ;дюммше мю фйх
          CALL      IN_PK1    ;-оепбши аюир
          CALL      ZAPIS     ;0001 0111
          CALL      PAUSE3    ;
          CALL      IN_PK7    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-брнпни аюир
          CALL      ZAPIS     ;0001 0101
          CALL      PAUSE3    ;
          MOVLW     .5        ;
          MOVWF     M_BYTE    ;
          CALL      IN_PORT   ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-рперхи аюир
          CALL      ZAPIS     ;0001 0101
          CALL      PAUSE3    ;
          MOVLW     .5        ;
          MOVWF     M_BYTE    ;
          CALL      IN_PORT   ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-вербепрши аюир-420-
          CALL      ZAPIS     ;0001 0101
          CALL      PAUSE3    ;
          MOVLW     .5        ;
          MOVWF     M_BYTE    ;
          CALL      IN_PORT   ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-оърши аюир
          CALL      ZAPIS     ;0001 0101
          CALL      PAUSE3    ;
          MOVLW     .5        ;
          MOVWF     M_BYTE    ;
          CALL      IN_PORT   ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-ьеярни аюир
          CALL      ZAPIS     ;0001 0101
          CALL      PAUSE3    ;
          MOVLW     .5        ;
          MOVWF     M_BYTE    ;-440-
          CALL      IN_PORT   ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-яедэлни аюир
          CALL      ZAPIS     ;0001 0101
          CALL      PAUSE3    ;
          MOVLW     .5        ;
          MOVWF     M_BYTE    ;
          CALL      IN_PORT   ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-бняэлни аюир
          CALL      ZAPIS     ;0001 0111
          CALL      PAUSE3    ;
          CALL      IN_PK7    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          RETURN              ;
MYSIMV11  CALL      IN_PK4    ;яр.онксаюир
          BCF       portb,2   ;йнлюмдю мю фйх
          CALL      ZAPIS     ;
          CALL      PAUSE3    ;
          MOVLW     .8        ;лкюдь.онксаюир
          MOVWF     M_BYTE    ;
          CALL      IN_PORT   ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
;гюохяэ яхлбнкю 11 б оепбсч ъвеийс CGRAM
          BSF       portb,2   ;дюммше мю фйх
          CALL      IN_PK0    ;-оепбши аюир
          CALL      ZAPIS     ;0000 1001
          CALL      PAUSE3    ;
          CALL      IN_PK9    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-брнпни аюир-480-
          CALL      ZAPIS     ;0001 1011
          CALL      PAUSE3    ;
          MOVLW     .11       ;
          MOVWF     M_BYTE    ;
          CALL      IN_PORT   ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK0    ;-рперхи аюир
          CALL      ZAPIS     ;0000 1001
          CALL      PAUSE3    ;
          CALL      IN_PK9    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK0    ;-вербепрши аюир
          CALL      ZAPIS     ;0000 1001
          CALL      PAUSE3    ;
          CALL      IN_PK9    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK0    ;-оърши аюир
          CALL      ZAPIS     ;0000 1001
          CALL      PAUSE3    ;
          CALL      IN_PK9    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK0    ;-ьеярни аюир-480
          CALL      ZAPIS     ;0000 1001
          CALL      PAUSE3    ;
          CALL      IN_PK9    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK0    ;-яедэлни аюир
          CALL      ZAPIS     ;0000 1001
          CALL      PAUSE3    ;
          CALL      IN_PK9    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK0    ;-бняэлни аюир
          CALL      ZAPIS     ;0000 1001
          CALL      PAUSE3    ;
          CALL      IN_PK9    ;
          CALL      ZAPIS     ;-520-
          CALL      PAUSE4    ;
          RETURN              ;
MYSIMV12  MOVLW     .5        ;яр.онксаюир
          MOVWF     M_BYTE    ;
          CALL      IN_PORT   ;
          BCF       portb,2   ;йнлюмдю мю фйх
          CALL      ZAPIS     ;
          CALL      PAUSE3    ;
          CALL      IN_PK0    ;лкюдь.онксаюир
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
;гюохяэ яхлбнкю 12 бн брнпсч ъвеийс CGRAM
          BSF       portb,2   ;дюммше мю фйх
          CALL      IN_PK1    ;-оепбши аюир
          CALL      ZAPIS     ;0001 0111
          CALL      PAUSE3    ;
          CALL      IN_PK7    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-брнпни аюир
          CALL      ZAPIS     ;0001 0001
          CALL      PAUSE3    ;
          CALL      IN_PK1    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-рперхи аюир
          CALL      ZAPIS     ;0001 0001
          CALL      PAUSE3    ;
          CALL      IN_PK1    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-вербепрши аюир
          CALL      ZAPIS     ;0001 0001
          CALL      PAUSE3    ;
          CALL      IN_PK1    ;
          CALL      ZAPIS     ;-560-
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-оърши аюир
          CALL      ZAPIS     ;0001 0010
          CALL      PAUSE3    ;
          MOVLW     .2        ;
          MOVWF     M_BYTE    ;
          CALL      IN_PORT   ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-ьеярни аюир
          CALL      ZAPIS     ;0001 0100
          CALL      PAUSE3    ;
          CALL      IN_PK4    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-яедэлни аюир
          CALL      ZAPIS     ;0001 0100
          CALL      PAUSE3    ;
          CALL      IN_PK4    ;
          CALL      ZAPIS     ;-580-
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-бняэлни аюир
          CALL      ZAPIS     ;0001 0111
          CALL      PAUSE3    ;
          CALL      IN_PK7    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          RETURN              ;
MYSIMV13  MOVLW     .5        ;яр.онксаюир
          MOVWF     M_BYTE    ;
          CALL      IN_PORT   ;
          BCF       portb,2   ;йнлюмдю мю фйх
          CALL      ZAPIS     ;
          CALL      PAUSE3    ;
          MOVLW     .8        ;лкюдь.онксаюир
          MOVWF     M_BYTE    ;
          CALL      IN_PORT   ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
;гюохяэ яхлбнкю 13 б рперэч ъвеийс CGRAM
          BSF       portb,2   ;дюммше мю фйх
          CALL      IN_PK1    ;-оепбши аюир
          CALL      ZAPIS     ;0001 0111
          CALL      PAUSE3    ;
          CALL      IN_PK7    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-брнпни аюир
          CALL      ZAPIS     ;0001 0001
          CALL      PAUSE3    ;
          CALL      IN_PK1    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-рперхи аюир
          CALL      ZAPIS     ;0001 0001
          CALL      PAUSE3    ;
          CALL      IN_PK1    ;
          CALL      ZAPIS     ;-620-
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-вербепрши аюир
          CALL      ZAPIS     ;0001 0111
          CALL      PAUSE3    ;
          CALL      IN_PK7    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-оърши аюир
          CALL      ZAPIS     ;0001 0111
          CALL      PAUSE3    ;
          CALL      IN_PK7    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-ьеярни аюир
          CALL      ZAPIS     ;0001 0001
          CALL      PAUSE3    ;
          CALL      IN_PK1    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-яедэлни аюир-640-
          CALL      ZAPIS     ;0001 0001
          CALL      PAUSE3    ;
          CALL      IN_PK1    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-бняэлни аюир
          CALL      ZAPIS     ;0001 0111
          CALL      PAUSE3    ;
          CALL      IN_PK7    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          RETURN              ;
MYSIMV14  MOVLW     .6        ;яр.онксаюир
          MOVWF     M_BYTE    ;
          CALL      IN_PORT   ;
          BCF       portb,2   ;йнлюмдю мю фйх
          CALL      ZAPIS     ;
          CALL      PAUSE3    ;
          CALL      IN_PK0    ;лкюдь.онксаюир
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
;гюохяэ яхлбнкю 14 б вербепрсч ъвеийс CGRAM
          BSF       portb,2   ;дюммше мю фйх
          CALL      IN_PK1    ;-оепбши аюир
          CALL      ZAPIS     ;0001 0101
          CALL      PAUSE3    ;
          MOVLW     .5        ;
          MOVWF     M_BYTE    ;
          CALL      IN_PORT   ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-брнпни аюир
          CALL      ZAPIS     ;0001 0101
          CALL      PAUSE3    ;
          MOVLW     .5        ;
          MOVWF     M_BYTE    ;-680-
          CALL      IN_PORT   ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-рперхи аюир
          CALL      ZAPIS     ;0001 0101
          CALL      PAUSE3    ;
          MOVLW     .5        ;
          MOVWF     M_BYTE    ;
          CALL      IN_PORT   ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-вербепрши аюир
          CALL      ZAPIS     ;0001 0111
          CALL      PAUSE3    ;
          CALL      IN_PK7    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-оърши аюир
          CALL      ZAPIS     ;0001 0111
          CALL      PAUSE3    ;-700-
          CALL      IN_PK7    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-ьеярни аюир
          CALL      ZAPIS     ;0001 0001
          CALL      PAUSE3    ;
          CALL      IN_PK1    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-яедэлни аюир
          CALL      ZAPIS     ;0001 0001
          CALL      PAUSE3    ;
          CALL      IN_PK1    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-бняэлни аюир
          CALL      ZAPIS     ;0001 0001
          CALL      PAUSE3    ;
          CALL      IN_PK1    ;
          CALL      ZAPIS     ;-720-
          CALL      PAUSE4    ;
          RETURN              ;
MYSIMV15  MOVLW     .6        ;яр.онксаюир
          MOVWF     M_BYTE    ;
          CALL      IN_PORT   ;
          BCF       portb,2   ;йнлюмдю мю фйх
          CALL      ZAPIS     ;
          CALL      PAUSE3    ;
          MOVLW     .8        ;лкюдь.онксаюир
          MOVWF     M_BYTE    ;
          CALL      IN_PORT   ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
;гюохяэ яхлбнкю 15 б оърсч ъвеийс CGRAM
          BSF       portb,2   ;дюммше мю фйх
          CALL      IN_PK1    ;-оепбши аюир
          CALL      ZAPIS     ;0001 0111
          CALL      PAUSE3    ;-740-
          CALL      IN_PK7    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-брнпни аюир
          CALL      ZAPIS     ;0001 0100
          CALL      PAUSE3    ;
          CALL      IN_PK4    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-рперхи аюир
          CALL      ZAPIS     ;0001 0100
          CALL      PAUSE3    ;
          CALL      IN_PK4    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-вербепрши аюир-760-
          CALL      ZAPIS     ;0001 0111
          CALL      PAUSE3    ;
          CALL      IN_PK7    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-оърши аюир
          CALL      ZAPIS     ;0001 0111
          CALL      PAUSE3    ;
          CALL      IN_PK7    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-ьеярни аюир
          CALL      ZAPIS     ;0001 0001
          CALL      PAUSE3    ;
          CALL      IN_PK1    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-яедэлни аюир
          CALL      ZAPIS     ;0001 0001
          CALL      PAUSE3    ;-780-
          CALL      IN_PK1    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          CALL      IN_PK1    ;-бняэлни аюир
          CALL      ZAPIS     ;0001 0111
          CALL      PAUSE3    ;
          CALL      IN_PK7    ;
          CALL      ZAPIS     ;
          CALL      PAUSE4    ;
          RETURN              ;
PROV_SIM  MOVLW     .16       ;гюохяэ б REZ
          MOVWF     T_PR      ;
P_S1      MOVLW     .15       ;
          ADDWF     T_PR,W    ;     
          MOVWF     fsr       ;
          MOVF      SECL_2,W  ;
          MOVWF     indf      ;
          DECFSZ    T_PR,F    ;
          GOTO      P_S1      ; 
          RETURN              ;
          END                 ;
